#include <amxmodx>
#include <amxmisc>
#include <cstrike>

#pragma semicolon 1

#define PLUGIN "ChangeModel (free) for amx-x.ru"
#define VERSION "1.0"
#define AUTHOR "Pain96"

#define CS_TEAM_T 1
#define CS_TEAM_CT 2

//								путь/имя конфигурационного файла; префикс в качестве ключа для setinfo, содержащий пароль; причина кика, если пароль не совпадает
new const g_Library[][] = {"", "/addons/amxmodx/configs/models.ini", "_mdl", "Неверный пароль"};

new szInfoPlayerModelCt[33], szInfoPlayerModelTt[33],
szAccessUser[33];

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	register_event("ResetHUD", "ChangeModel", "b");
}

public plugin_precache()
{
	new szInfo[256], szInfoPrecache[128], 
	szInfoUser[32], szInfoUserPassword[32], 
	szInfoModelCt[64], szInfoModelTt[64], 
	iNum;
	
	for(new iLine = 0; read_file(g_Library[1], iLine, szInfo, charsmax(szInfo), iNum); iLine++) 
	{
		if(iNum && szInfo[0] != ';')
		{
			parse(szInfo, szInfoUser, charsmax( szInfoUser ), 
			szInfoUserPassword, charsmax(szInfoUserPassword), 
			szInfoModelCt, charsmax(szInfoModelCt),
			szInfoModelTt, charsmax(szInfoModelTt)
			);
			
			formatex(szInfoPrecache, charsmax(szInfoPrecache), "models/player/%s/%s.mdl", szInfoModelCt, szInfoModelCt);
			precache_model(szInfoPrecache);
			formatex(szInfoPrecache, charsmax(szInfoPrecache), "models/player/%s/%s.mdl", szInfoModelTt, szInfoModelTt);
			precache_model(szInfoPrecache);
		}
	}
}

public client_connect(id)
{
	set_task(0.5, "CheckPlayerInfo", id);
	szAccessUser[id] = false;
	szInfoPlayerModelCt[id] = false;
	szInfoPlayerModelTt[id] = false;
}

public client_infochanged(id)
{
	set_task(0.5, "CheckPlayerInfo", id);
	szAccessUser[id] = false;
	szInfoPlayerModelCt[id] = false;
	szInfoPlayerModelTt[id] = false;
}

public CheckPlayerInfo(id)
{	
	new szInfo[256], szName[32], 
	szSteam[32], szIP[32], 
	szPassword[32], szInfoUser[32], 
	szInfoUserPassword[32], szInfoModelCt[64], 
	szInfoModelTt[64], iNum;
	
	if (!is_user_connected(id))
		return 0;
		
	get_user_name(id, szName, charsmax(szName));
	get_user_authid(id, szSteam, charsmax(szSteam));
	get_user_ip(id, szIP, charsmax(szIP), 1);
	
	for(new iLine = 0; read_file(g_Library[1], iLine, szInfo, charsmax(szInfo), iNum); iLine++) 
	{
		if(iNum && szInfo[0] != ';')
		{
			parse(szInfo, szInfoUser, charsmax( szInfoUser ),
			szInfoUserPassword, charsmax(szInfoUserPassword),
			szInfoModelCt, charsmax(szInfoModelCt), 
			szInfoModelTt, charsmax(szInfoModelTt)
			);

			if (equal(szName, szInfoUser))
			{
				get_user_info(id, g_Library[2], szPassword, charsmax(szPassword));
				
				if(!equal(szInfoUserPassword, szPassword))
					return server_cmd("kick %s ^"%s^"", szName, g_Library[3]);
				
				copy(szInfoPlayerModelCt[id], charsmax(szInfoPlayerModelCt), szInfoModelCt);
				copy(szInfoPlayerModelTt[id], charsmax(szInfoPlayerModelTt), szInfoModelTt);
				szAccessUser[id] = true;
				break;
			}
			else if (equal(szSteam, szInfoUser))
			{				
				copy(szInfoPlayerModelCt[id], charsmax(szInfoPlayerModelCt), szInfoModelCt);
				copy(szInfoPlayerModelTt[id], charsmax(szInfoPlayerModelTt), szInfoModelTt);
				szAccessUser[id] = true;
				break;
			}
			else if (equal(szIP, szInfoUser))
			{
				copy(szInfoPlayerModelCt[id], charsmax(szInfoPlayerModelCt), szInfoModelCt);
				copy(szInfoPlayerModelTt[id], charsmax(szInfoPlayerModelTt), szInfoModelTt);
				szAccessUser[id] = true;
				break;
			}
		}
	}
	return 1;
}

public ChangeModel(id, level, cid)
{
	if (szAccessUser[id])
	{
		new iTeam = get_user_team(id);
		switch(iTeam)
		{
			case CS_TEAM_T: cs_set_user_model(id, szInfoPlayerModelTt[id]);
			case CS_TEAM_CT: cs_set_user_model(id, szInfoPlayerModelCt[id]);

			default: cs_reset_user_model(id);
		}
	}
	return 0;
}